com.corticon.services.datasource

## Interface IDatasource

-     public interface IDatasource

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `TYPE_DATABASE` TYPE_DATABASE: A database connection type as described in the datasource config file.
    `static java.lang.String` | `TYPE_EDC` TYPE_EDC: This is the EDC data connection for this decision service.
    `static java.lang.String` | `TYPE_QUERY` TYPE_QUERY: A query datasource type as described in the datasource config file.
    `static java.lang.String` | `TYPE_REST` TYPE_REST: A rest datasource type as described in the datasource config file.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getDatasourceAuthenticationDomain()` Provides the Domain portion of the NTLM authentication information that this datasource was configured for.
    `java.lang.String` | `getDatasourceAuthenticationType()` If this has a specified authentication type, This is currently only used by Rest Datasources.
    `java.lang.String` | `getDatasourceCatalogFilter()` If this is an EDC connection, there may be a Catalog filter provided in the configuration.
    `java.lang.String` | `getDatasourceClientID()` Provides the Client ID portion of the OAuth2 authentication information that this datasource was configured for.
    `java.lang.String` | `getDatasourceClientSecret()` Provides the Client Secret portion of the OAuth2 authentication information that this datasource was configured for.
    `java.lang.String` | `getDatasourceConnectionURL()` Returns either the URL or the connection string for the datasource connection.
    `java.lang.String` | `getDatasourceDescription()` Returns a human readable description of this datasource.
    `java.lang.String` | `getDatasourceDriverId()` If this is a database or EDC connection, there will be a corticon database driver for the associated database, calling this method will return the ID of the database driver.
    `java.lang.String` | `getDatasourceFieldName()` Provides the token portion of the authentication information that this datasource was configured for.
    `java.lang.String` | `getDatasourceName()` Returns the name of this datasource, this is generally used to look up the datasource and associated configuration.
    `java.lang.String` | `getDatasourcePassword()` Returns the password portion of the login information (if any) that this datasource was configured for.
    `java.util.Properties` | `getDatasourceProperties()` Gets the property object representing all the datasource's properties, this includes the database driver ID and login information for applicable datasources.
    `java.lang.String` | `getDatasourceSchemaFilter()` If this is an EDC connection, there may be a Schema filter provided in the configuration.
    `java.lang.String` | `getDatasourceToken()` Provides the token portion of the authentication information that this datasource was configured for.
    `java.lang.String` | `getDatasourceTokenURI()` Provides the Token URI portion of the OAuth2 authentication information that this datasource was configured for.
    `java.lang.String` | `getDatasourceType()` Returns the type of datasource connection this is, different connections can be accessed differently.
    `java.lang.String` | `getDatasourceUserName()` Returns the username portion of the login information (if any) that this datasource was configured for.
    `java.lang.String` | `getDatsourceProperty(java.lang.String astrMappingPropertyName)` Gets the value for a particular configuration property, this is commonly used in database connections, where particular databases drivers may need additional properties set specific to the driver.
    `boolean` | `getUseKerberosAuthentication()` Determines if this datasource was configured for kerberos or username/password authentication.

- - ### Field Detail

    - #### TYPE_EDC

          static final java.lang.String TYPE_EDC

      TYPE_EDC: This is the EDC data connection for this decision service. This is a possible datasource type, as returned by getDatasourceType.
      See Also:
        Constant Field Values

    - #### TYPE_DATABASE

          static final java.lang.String TYPE_DATABASE

      TYPE_DATABASE: A database connection type as described in the datasource config file. This is a possible datasource type, as returned by getDatasourceType.
      See Also:
        Constant Field Values

    - #### TYPE_QUERY

          static final java.lang.String TYPE_QUERY

      TYPE_QUERY: A query datasource type as described in the datasource config file. This is a possible datasource type, as returned by getDatasourceType.
      See Also:
        Constant Field Values

    - #### TYPE_REST

          static final java.lang.String TYPE_REST

      TYPE_REST: A rest datasource type as described in the datasource config file. This is a possible datasource type, as returned by getDatasourceType.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getDatasourceType

          java.lang.String getDatasourceType()

      Returns the type of datasource connection this is, different connections can be accessed differently.
      Returns:
        Either TYPE_EDC, TYPE_DATABASE, or TYPE_QUERY

    - #### getDatasourceName

          java.lang.String getDatasourceName()

      Returns the name of this datasource, this is generally used to look up the datasource and associated configuration.
      Returns:
        datasource configuration name.

    - #### getDatasourceDescription

          java.lang.String getDatasourceDescription()

      Returns a human readable description of this datasource.
      Returns:
        A string containing text that descripbes the datasource.

    - #### getDatasourceUserName

          java.lang.String getDatasourceUserName()

      Returns the username portion of the login information (if any) that this datasource was configured for.
      Returns:
        The username if one was configured, otherwise an empty string is returned.

    - #### getDatasourcePassword

          java.lang.String getDatasourcePassword()

      Returns the password portion of the login information (if any) that this datasource was configured for.
      Returns:
        The password if one was configured, otherwise null is returned.

    - #### getDatasourceToken

          java.lang.String getDatasourceToken()

      Provides the token portion of the authentication information that this datasource was configured for.
      Returns:
        The Token if used by this datasource, otherwise null will be returned.

    - #### getDatasourceFieldName

          java.lang.String getDatasourceFieldName()

      Provides the token portion of the authentication information that this datasource was configured for.
      Returns:
        The Field Name if used by this datasource, otherwise null will be returned.

    - #### getUseKerberosAuthentication

          boolean getUseKerberosAuthentication()

      Determines if this datasource was configured for kerberos or username/password authentication.
      Returns:
        true if this datasource is configured for, and supports kerberos authentication. false if the datasource does not support kerberos or does not have kerberos configured.

    - #### getDatasourceAuthenticationType

          java.lang.String getDatasourceAuthenticationType()

      If this has a specified authentication type, This is currently only used by Rest Datasources.
      Returns:
        A string representing the type of Authentication used.

    - #### getDatasourceConnectionURL

          java.lang.String getDatasourceConnectionURL()

      Returns either the URL or the connection string for the datasource connection. The format of this will generally be the same as a URL in either case: `protocol://hostname:port/path{options}`
      Returns:
        Either a URL or a connection string for the datasource.

    - #### getDatasourceDriverId

          java.lang.String getDatasourceDriverId()

      If this is a database or EDC connection, there will be a corticon database driver for the associated database, calling this method will return the ID of the database driver. i.e. com.corticon.database.id.OE11.7 if the driver is for Open Edge 11.7
      Returns:
        A string containing the ID of the database driver used or null if none exist

    - #### getDatasourceSchemaFilter

          java.lang.String getDatasourceSchemaFilter()

      If this is an EDC connection, there may be a Schema filter provided in the configuration. Return the configured Schema filter.
      Returns:
        The Schema Filter for this Datasource.

    - #### getDatasourceCatalogFilter

          java.lang.String getDatasourceCatalogFilter()

      If this is an EDC connection, there may be a Catalog filter provided in the configuration. Return the configured catalog filter.
      Returns:
        The Catalog Filter for this Datasource.

    - #### getDatsourceProperty

          java.lang.String getDatsourceProperty(java.lang.String astrMappingPropertyName)

      Gets the value for a particular configuration property, this is commonly used in database connections, where particular databases drivers may need additional properties set specific to the driver.
      Parameters:
        `astrMappingPropertyName` - The property you wish to retrieve the value of.
      Returns:
        A string representation of the value of the property.

    - #### getDatasourceProperties

          java.util.Properties getDatasourceProperties()

      Gets the property object representing all the datasource's properties, this includes the database driver ID and login information for applicable datasources. It also includes the Database driver specific properties for EDC and Database type datasources.
      Returns:
        A properties object containing all the properties for this datasource.

    - #### getDatasourceClientID

          java.lang.String getDatasourceClientID()

      Provides the Client ID portion of the OAuth2 authentication information that this datasource was configured for.
      Returns:
        The Client ID if used by this datasource, otherwise null will be returned.

    - #### getDatasourceTokenURI

          java.lang.String getDatasourceTokenURI()

      Provides the Token URI portion of the OAuth2 authentication information that this datasource was configured for.
      Returns:
        The Token URI if used by this datasource, otherwise null will be returned.

    - #### getDatasourceClientSecret

          java.lang.String getDatasourceClientSecret()

      Provides the Client Secret portion of the OAuth2 authentication information that this datasource was configured for.
      Returns:
        The Client Secret if used by this datasource, otherwise null will be returned.

    - #### getDatasourceAuthenticationDomain

          java.lang.String getDatasourceAuthenticationDomain()

      Provides the Domain portion of the NTLM authentication information that this datasource was configured for.
      Returns:
        The Domain if used by this datasource, otherwise null will be returned.

Copyright © 2005-2023 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.